"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utilities = require("../utilities");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NatterlyChat = function () {
  function NatterlyChat(data, client) {
    var _this = this;

    _classCallCheck(this, NatterlyChat);

    this.client = client;
    this.data = data;
    this.closed = false;
    // Event listeners
    this.client.on("ChatClosed", function (data) {
      if (_this.data.uuid === data.uuid) {
        _this.closed = true;
      }
    });
  }

  _createClass(NatterlyChat, [{
    key: "close",
    value: function close(callback) {
      var body = { chat: this.data.uuid };
      this._actionRequest("chats_for_sessions/close", body, callback);
    }
  }, {
    key: "sendTranscript",
    value: function sendTranscript(emailAddress, callback) {
      var body = {
        chat: this.data.uuid,
        email_address: emailAddress
      };
      if ((0, _utilities.requiredFields)("sendTranscript", { emailAddress: emailAddress })) {
        this._actionRequest("chats_for_sessions/send_transcript", body, callback);
      }
    }
  }, {
    key: "messages",
    value: function messages() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments[1];

      var _assignFlexibleCallba = (0, _utilities.assignFlexibleCallbackArgs)(options, callback);

      options = _assignFlexibleCallba.options;
      callback = _assignFlexibleCallba.callback;
      var _options = options,
          page = _options.page,
          per_page = _options.per_page,
          after = _options.after,
          before = _options.before;

      var body = {
        chat: this.data.uuid,
        page: page,
        per_page: per_page,
        after: after,
        before: before
      };
      this._actionRequest("chats_for_sessions/messages", body, callback);
    }
  }, {
    key: "sendMessage",
    value: function sendMessage(text) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var callback = arguments[2];

      var body = _extends({
        chat: this.data.uuid,
        text: text
      }, options);
      this._actionRequest("chats_for_sessions/send_message", body, callback);
    }
  }, {
    key: "setRating",
    value: function setRating(rating) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var callback = arguments[2];

      var _assignFlexibleCallba2 = (0, _utilities.assignFlexibleCallbackArgs)(options, callback);

      options = _assignFlexibleCallba2.options;
      callback = _assignFlexibleCallba2.callback;

      var body = _extends({
        chat: this.data.uuid,
        rating: rating
      }, options);
      this._actionRequest("chats_for_sessions/set_rating", body, callback);
    }

    // Private methods

  }, {
    key: "_actionRequest",
    value: function _actionRequest(endpoint, body, callback) {
      this.client._actionRequest(endpoint, body, callback);
    }
  }]);

  return NatterlyChat;
}();

exports.default = NatterlyChat;