"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utilities = require("../utilities");

var _NatterlyEvent = require("./NatterlyEvent");

var _NatterlyEvent2 = _interopRequireDefault(_NatterlyEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NatterlyReactor = function () {
  function NatterlyReactor() {
    _classCallCheck(this, NatterlyReactor);

    this.events = {};
  }

  _createClass(NatterlyReactor, [{
    key: "registerEvent",
    value: function registerEvent(eventName) {
      var event = new _NatterlyEvent2.default(eventName);
      this.events[eventName] = event;
    }
  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(eventName, payload) {
      (0, _utilities.logger)(eventName, payload);
      var event = this.events[eventName];
      if (event && event.callbacks) {
        event.callbacks.forEach(function (callback) {
          callback(payload);
        });
      }
    }
  }, {
    key: "addEventListener",
    value: function addEventListener(eventName, callback) {
      var event = this.events[eventName];
      if (event && typeof callback === "function") {
        event.registerCallback(callback);
      } else {
        console.warn("NatterlyClient: failed to add event listener for \"" + eventName + "\"");
      }
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(eventName, callback) {
      var event = this.events[eventName];
      if (event && event.callbacks.indexOf(callback) > -1) {
        event.unregisterCallback(callback);
      } else {
        console.warn("Could not remove provided event listener for \"" + eventName + "\" as it does not exist");
      }
    }
  }]);

  return NatterlyReactor;
}();

exports.default = NatterlyReactor;