"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _superagent = require("superagent");

var _superagent2 = _interopRequireDefault(_superagent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultHeaders = { "Content-Type": "application/json" };

function apiRequest(url, data, callback) {
  var headers = _extends({}, defaultHeaders, data.headers);
  return _superagent2.default.post(url).set(headers).send(data.body).end(function (err, res) {
    if (err) {
      console.error(err);
    } else if (res.statusCode === 200) {
      var info = JSON.parse(res.text);
      var success = info.status === "success";

      callback(success, info.data, info.flags);
    }
  });
}

exports.default = apiRequest;